addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid and player.charability == CA_THOK and player.mo.skin == "sonic"
	and not (player.pflags & PF_THOKKED) and player.dashmode < 3*TICRATE
		P_Thrust(player.mo, player.mo.angle, 27*FRACUNIT) 
		P_SetObjectMomZ(player.mo, player.speed/9, true)
		P_SpawnThokMobj(player)
		S_StartSound(player.mo, sfx_thok) 
		player.pflags = $|PF_THOKKED
		player.mo.state = S_PLAY_ROLL
	elseif player.mo and player.mo.valid and player.charability == CA_THOK and player.mo.skin == "sonic"
	and not (player.pflags & PF_THOKKED) and player.dashmode > 3*TICRATE
		P_Thrust(player.mo, player.mo.angle, 44*FRACUNIT) 
		P_SetObjectMomZ(player.mo, player.speed/9, true)
		P_SpawnThokMobj(player)
		S_StartSound(player.mo, sfx_zoom)
		player.pflags = $|PF_THOKKED
		player.mo.state = S_PLAY_ROLL
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "sonic" and player.dashmode > 3*TICRATE
		P_SpawnThokMobj(player)
		player.mo.colorized = false
	end
end)